﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;

namespace esl
{
    class DocumentAttributes
    {
        public static void start()
        {
            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Add("Authorization", "Basic " + Properties.Settings.Default.key);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");

            string jsonString = "{\"autocomplete\":true,\"documents\":[{\"approvals\":[{\"fields\":[{\"extract\":false,\"height\":50,\"left\":100,\"page\":0,\"subtype\":\"FULLNAME\",\"top\":100,\"type\":\"SIGNATURE\",\"width\":200}],\"role\":\"Client1\"}],\"data\":{\"Department\":\"1806\",\"Employee\":\"135526\"},\"extract\":false,\"fields\":[],\"index\":0,\"name\":\"sample doc\",\"pages\":[]}],\"emailMessage\":\"\",\"messages\":[],\"name\":\"asd\",\"roles\":[{\"attachmentRequirements\":[],\"id\":\"Client1\",\"index\":0,\"locked\":false,\"name\":\"Client1\",\"reassign\":false,\"signers\":[{\"auth\":{\"challenges\":[],\"scheme\":\"NONE\"},\"company\":\"Acme Inc.\",\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"id\":\"Client1\",\"lastName\":\"Smith\",\"professionalIdentityFields\":[],\"specialTypes\":[],\"title\":\"Managing Director\",\"userCustomFields\":[]}],\"specialTypes\":[]}],\"trashed\":false,\"type\":\"PACKAGE\",\"visibility\":\"ACCOUNT\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("C:/Users/hhaidary/Desktop/pdfs/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            var response = httpClient.PostAsync(new Uri("https://sandbox.esignlive.com/packages"), form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
